diff -ruN a/include/vmr9.h b/include/vmr9.h
--- a/include/vmr9.h	2008-12-06 03:32:11.000000000 +0100
+++ b/include/vmr9.h	2010-04-25 13:03:46.891124634 +0200
@@ -8,6 +8,10 @@
 extern "C" {
 #endif
 
+EXTERN_C const IID IID_IVMRFilterConfig9;
+EXTERN_C const IID IID_IVMRWindowlessControl9;
+EXTERN_C const IID IID_IVMRMixerControl9;
+
 /*--- DirectShow Reference - DirectShow Enumerated Types */
 typedef enum _VMR9_SampleFormat {
 	VMR9_SampleReserved = 1,
@@ -61,7 +65,7 @@
 	MixerPref9_RenderTargetRGB = 0x00001000,
 	MixerPref9_RenderTargetYUV = 0x00002000,
 	MixerPref9_RenderTargetReserved = 0x000FC000,
-	MixerPref9_RenderTargetMask = 0x000FF000
+	MixerPref9_RenderTargetMask = 0x000FF000,
 	MixerPref9_DynamicSwitchToBOB = 0x00100000,
 	MixerPref9_DynamicDecimateBy2 = 0x00200000,
 	MixerPref9_DynamicReserved = 0x00C00000,
@@ -128,7 +132,7 @@
 	HMONITOR hMon;
 	DWORD dwFlags;
 	wchar_t szDevice[32];
-	wchar_t szDescription[512]
+	wchar_t szDescription[512];
 	LARGE_INTEGER liDriverVersion;
 	DWORD dwVendorId;
 	DWORD dwDeviceId;
@@ -181,7 +185,6 @@
 	VMR9Frequency InputSampleFreq;
 	VMR9Frequency OutputFrameFreq;
 } VMR9VideoDesc;
-/**********
 typedef struct VMR9VideoStreamInfo{
 	IDirect3DSurface9 *pddsVideoSurface;
 	DWORD dwWidth;
@@ -203,8 +206,64 @@
 	COLORREF clrSrcKey;
 	DWORD dwFilterMode;
 };
-**********/
-
+#define INTERFACE IVMRImageCompositor9
+DECLARE_INTERFACE_(IVMRImageCompositor9, IUnknown)
+{
+    STDMETHOD(InitCompositionDevice)(THIS_ IUnknown *) PURE;
+    STDMETHOD(TermCompositionDevice)(THIS_ IUnknown *) PURE;
+    STDMETHOD(SetStreamMediaType)(THIS_ DWORD, AM_MEDIA_TYPE *, BOOL) PURE;
+    STDMETHOD(CompositeImage)(THIS_ IUnknown *, IDirect3DSurface9 *, AM_MEDIA_TYPE *,
+        REFERENCE_TIME, REFERENCE_TIME, D3DCOLOR, VMR9VideoStreamInfo *, UINT) PURE;
+};
+#undef INTERFACE
+#define INTERFACE IVMRFilterConfig9
+DECLARE_INTERFACE_(IVMRFilterConfig9, IUnknown)
+{
+    STDMETHOD(SetImageCompositor)(THIS_ IVMRImageCompositor9 *) PURE;
+    STDMETHOD(SetNumberOfStreams)(THIS_ DWORD) PURE;
+    STDMETHOD(GetNumberOfStreams)(THIS_ DWORD *) PURE;
+    STDMETHOD(SetRenderingPrefs)(THIS_ DWORD) PURE;
+    STDMETHOD(GetRenderingPrefs)(THIS_ DWORD *) PURE;
+    STDMETHOD(SetRenderingMode)(THIS_ DWORD) PURE;
+    STDMETHOD(GetRenderingMode)(THIS_ DWORD *) PURE;
+};
+#undef INTERFACE
+#define INTERFACE IVMRWindowlessControl9
+DECLARE_INTERFACE_(IVMRWindowlessControl9, IUnknown)
+{
+    STDMETHOD(GetNativeVideoSize)(THIS_ LONG *, LONG *, LONG *, LONG *) PURE;
+    STDMETHOD(GetMinIdealVideoSize)(THIS_ LONG *, LONG *) PURE;
+    STDMETHOD(GetMaxIdealVideoSize)(THIS_ LONG *, LONG *) PURE;
+    STDMETHOD(SetVideoPosition)(THIS_ const LPRECT, const LPRECT) PURE;
+    STDMETHOD(GetVideoPosition)(THIS_ LPRECT, LPRECT) PURE;
+    STDMETHOD(GetAspectRatioMode)(THIS_ DWORD *) PURE;
+    STDMETHOD(SetAspectRatioMode)(THIS_ DWORD) PURE;
+    STDMETHOD(SetVideoClippingWindow)(THIS_ HWND) PURE;
+    STDMETHOD(RepaintVideo)(THIS_ HWND, HDC) PURE;
+    STDMETHOD(DisplayModeChanged)(THIS) PURE;
+    STDMETHOD(GetCurrentImage)(THIS_ BYTE **) PURE;
+    STDMETHOD(SetBorderColor)(THIS_ COLORREF) PURE;
+    STDMETHOD(GetBorderColor)(THIS_ COLORREF *) PURE;
+};
+#undef INTERFACE
+#define INTERFACE IVMRMixerControl9
+DECLARE_INTERFACE_(IVMRMixerControl9, IUnknown)
+{
+    STDMETHOD(SetAlpha)(THIS_ DWORD, float) PURE;
+    STDMETHOD(GetAlpha)(THIS_ DWORD, float *) PURE;
+    STDMETHOD(SetZOrder)(THIS_ DWORD, DWORD) PURE;
+    STDMETHOD(GetZOrder)(THIS_ DWORD, DWORD *) PURE;
+    STDMETHOD(SetOutputRect)(THIS_ DWORD, const VMR9NormalizedRect *) PURE;
+    STDMETHOD(GetOutputRect)(THIS_ DWORD, VMR9NormalizedRect *) PURE;
+    STDMETHOD(SetBackgroundClr)(THIS_ COLORREF) PURE;
+    STDMETHOD(GetBackgroundClr)(THIS_ COLORREF *) PURE;
+    STDMETHOD(SetMixingPrefs)(THIS_ DWORD) PURE;
+    STDMETHOD(GetMixingPrefs)(THIS_ DWORD *) PURE;
+    STDMETHOD(SetProcAmpControl)(THIS_ DWORD, VMR9ProcAmpControl *) PURE;
+    STDMETHOD(GetProcAmpControl)(THIS_ DWORD, VMR9ProcAmpControl *) PURE;
+    STDMETHOD(GetProcAmpControlRange)(THIS_ DWORD, VMR9ProcAmpControlRange *) PURE;
+};
+#undef INTERFACE
 #ifdef __cplusplus
 }
 #endif
